"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isNullish = isNullish;
exports.isBoolean = isBoolean;
exports.isString = isString;
exports.isNumber = isNumber;
exports.isRecord = isRecord;
exports.isArray = isArray;
exports.isPlacement = isPlacement;
function isNullish(value) {
    return value === null || value === undefined;
}
function isBoolean(value) {
    return typeof value === 'boolean';
}
function isString(value) {
    return typeof value === 'string';
}
function isNumber(value) {
    return typeof value === 'number';
}
function isRecord(value) {
    return typeof value === 'object' && value !== null && !Array.isArray(value);
}
function isArray(value, checkItem) {
    return Array.isArray(value) && value.every(checkItem);
}
function isPlacement(value) {
    return (isArray(value, isString) &&
        value.length === 2 &&
        ['before', 'after'].includes(value[0]));
}
//# sourceMappingURL=guardUtils.js.map