"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isStructuredTextCustomMark = isStructuredTextCustomMark;
exports.isReturnTypeOfCustomMarksForStructuredTextFieldHook = isReturnTypeOfCustomMarksForStructuredTextFieldHook;
var guardUtils_js_1 = require("../guardUtils.js");
var icon_1 = require("../icon");
function isStructuredTextCustomMark(value) {
    return ((0, guardUtils_js_1.isRecord)(value) &&
        (0, guardUtils_js_1.isString)(value.id) &&
        (0, guardUtils_js_1.isString)(value.label) &&
        (0, icon_1.isIcon)(value.icon) &&
        ((0, guardUtils_js_1.isNullish)(value.placement) || (0, guardUtils_js_1.isPlacement)(value.placement)) &&
        ((0, guardUtils_js_1.isNullish)(value.rank) || (0, guardUtils_js_1.isNumber)(value.rank)) &&
        ((0, guardUtils_js_1.isNullish)(value.keyboardShortcut) || (0, guardUtils_js_1.isString)(value.keyboardShortcut)) &&
        (0, guardUtils_js_1.isRecord)(value.appliedStyle));
}
function isReturnTypeOfCustomMarksForStructuredTextFieldHook(value) {
    return (0, guardUtils_js_1.isNullish)(value) || (0, guardUtils_js_1.isArray)(value, isStructuredTextCustomMark);
}
//# sourceMappingURL=customMarksForStructuredTextField.js.map