import { isArray, isNullish, isNumber, isRecord, isString, } from '../guardUtils.js';
import { isIcon } from '../icon';
export function isAssetSource(value) {
    if (isNullish(value))
        return false;
    if (!isRecord(value))
        return false;
    var id = value.id, name = value.name, icon = value.icon, modal = value.modal;
    return (isString(id) &&
        isString(name) &&
        isIcon(icon) &&
        (isNullish(modal) ||
            (isRecord(modal) &&
                (isNullish(modal.width) ||
                    (isString(modal.width) &&
                        ['s', 'm', 'l', 'xl'].includes(modal.width)) ||
                    isNumber(modal.width)) &&
                (isNullish(modal.initialHeight) || isNumber(modal.initialHeight)))));
}
export function isReturnTypeOfAssetSourcesHook(value) {
    return isNullish(value) || isArray(value, isAssetSource);
}
//# sourceMappingURL=assetSources.js.map