import { isArray, isNullish, isNumber, isPlacement, isRecord, isString, } from '../guardUtils.js';
import { isIcon } from '../icon';
export function isStructuredTextCustomMark(value) {
    return (isRecord(value) &&
        isString(value.id) &&
        isString(value.label) &&
        isIcon(value.icon) &&
        (isNullish(value.placement) || isPlacement(value.placement)) &&
        (isNullish(value.rank) || isNumber(value.rank)) &&
        (isNullish(value.keyboardShortcut) || isString(value.keyboardShortcut)) &&
        isRecord(value.appliedStyle));
}
export function isReturnTypeOfCustomMarksForStructuredTextFieldHook(value) {
    return isNullish(value) || isArray(value, isStructuredTextCustomMark);
}
//# sourceMappingURL=customMarksForStructuredTextField.js.map