import type { AssetSourcesHook } from './hooks/assetSources';
import type { BuildItemPresentationInfoHook } from './hooks/buildItemPresentationInfo';
import type { ContentAreaSidebarItemsHook } from './hooks/contentAreaSidebarItems';
import type { CustomBlockStylesForStructuredTextFieldHook } from './hooks/customBlockStylesForStructuredTextField';
import type { CustomMarksForStructuredTextFieldHook } from './hooks/customMarksForStructuredTextField';
import type { ExecuteFieldDropdownActionHook } from './hooks/executeFieldDropdownAction';
import type { ExecuteItemFormDropdownActionHook } from './hooks/executeItemFormDropdownAction';
import type { ExecuteItemsDropdownActionHook } from './hooks/executeItemsDropdownAction';
import type { ExecuteSchemaItemTypeDropdownActionHook } from './hooks/executeSchemaItemTypeDropdownAction';
import type { ExecuteUploadsDropdownActionHook } from './hooks/executeUploadsDropdownAction';
import type { FieldDropdownActionsHook } from './hooks/fieldDropdownActions';
import type { InitialLocationQueryForItemSelectorHook } from './hooks/initialLocationQueryForItemSelector';
import type { ItemCollectionOutletsHook } from './hooks/itemCollectionOutlets';
import type { ItemFormDropdownActionsHook } from './hooks/itemFormDropdownActions';
import type { ItemFormOutletsHook } from './hooks/itemFormOutlets';
import type { ItemFormSidebarPanelsHook } from './hooks/itemFormSidebarPanels';
import type { ItemFormSidebarsHook } from './hooks/itemFormSidebars';
import type { ItemsDropdownActionsHook } from './hooks/itemsDropdownActions';
import type { MainNavigationTabsHook } from './hooks/mainNavigationTabs';
import type { ManualFieldExtensionsHook } from './hooks/manualFieldExtensions';
import type { OnBeforeItemUpsertHook } from './hooks/onBeforeItemUpsert';
import type { OnBeforeItemsDestroyHook } from './hooks/onBeforeItemsDestroy';
import type { OnBeforeItemsPublishHook } from './hooks/onBeforeItemsPublish';
import type { OnBeforeItemsUnpublishHook } from './hooks/onBeforeItemsUnpublish';
import type { OnBootHook } from './hooks/onBoot';
import type { OverrideFieldExtensionsHook } from './hooks/overrideFieldExtensions';
import { RenderAssetSourceHook } from './hooks/renderAssetSource';
import { RenderConfigScreenHook } from './hooks/renderConfigScreen';
import { RenderFieldExtensionHook } from './hooks/renderFieldExtension';
import { RenderItemCollectionOutletHook } from './hooks/renderItemCollectionOutlet';
import { RenderItemFormOutletHook } from './hooks/renderItemFormOutlet';
import { RenderItemFormSidebarHook } from './hooks/renderItemFormSidebar';
import { RenderItemFormSidebarPanelHook } from './hooks/renderItemFormSidebarPanel';
import { RenderManualFieldExtensionConfigScreenHook } from './hooks/renderManualFieldExtensionConfigScreen';
import { RenderModalHook } from './hooks/renderModal';
import { RenderPageHook } from './hooks/renderPage';
import { RenderUploadSidebarHook } from './hooks/renderUploadSidebar';
import { RenderUploadSidebarPanelHook } from './hooks/renderUploadSidebarPanel';
import type { SchemaItemTypeDropdownActionsHook } from './hooks/schemaItemTypeDropdownActions';
import type { SettingsAreaSidebarItemGroupsHook } from './hooks/settingsAreaSidebarItemGroups';
import { UploadSidebarPanelsHook } from './hooks/uploadSidebarPanels';
import { UploadSidebarsHook } from './hooks/uploadSidebars';
import type { UploadsDropdownActionsHook } from './hooks/uploadsDropdownActions';
import type { ValidateManualFieldExtensionParametersHook } from './hooks/validateManualFieldExtensionParameters';
/** The full options you can pass to the `connect` function */
export type FullConnectParameters = AssetSourcesHook & BuildItemPresentationInfoHook & ContentAreaSidebarItemsHook & CustomBlockStylesForStructuredTextFieldHook & CustomMarksForStructuredTextFieldHook & ExecuteFieldDropdownActionHook & ExecuteItemFormDropdownActionHook & ExecuteItemsDropdownActionHook & ExecuteSchemaItemTypeDropdownActionHook & ExecuteUploadsDropdownActionHook & FieldDropdownActionsHook & InitialLocationQueryForItemSelectorHook & ItemCollectionOutletsHook & ItemFormDropdownActionsHook & ItemFormOutletsHook & ItemFormSidebarPanelsHook & ItemFormSidebarsHook & ItemsDropdownActionsHook & MainNavigationTabsHook & ManualFieldExtensionsHook & OnBeforeItemsDestroyHook & OnBeforeItemsPublishHook & OnBeforeItemsUnpublishHook & OnBeforeItemUpsertHook & OnBootHook & OverrideFieldExtensionsHook & RenderAssetSourceHook & RenderConfigScreenHook & RenderFieldExtensionHook & RenderItemCollectionOutletHook & RenderItemFormOutletHook & RenderItemFormSidebarHook & RenderItemFormSidebarPanelHook & RenderManualFieldExtensionConfigScreenHook & RenderModalHook & RenderPageHook & RenderUploadSidebarHook & RenderUploadSidebarPanelHook & SchemaItemTypeDropdownActionsHook & SettingsAreaSidebarItemGroupsHook & UploadsDropdownActionsHook & UploadSidebarPanelsHook & UploadSidebarsHook & ValidateManualFieldExtensionParametersHook;
export declare function connect(rawConfiguration?: Partial<FullConnectParameters>): Promise<void>;
