import { ItemFormAdditionalMethods, ItemFormAdditionalProperties } from '../ctx/commonExtras/itemForm';
import { SelfResizingPluginFrameCtx } from '../ctx/pluginFrame';
export type RenderItemFormOutletHook = {
    /**
     * This function will be called when the plugin needs to render an outlet
     * defined by the `itemFormOutlets()` hook.
     *
     * @tag outlets
     */
    renderItemFormOutlet: (itemFormOutletId: string, ctx: RenderItemFormOutletCtx) => void;
};
export type RenderItemFormOutletCtx = SelfResizingPluginFrameCtx<'renderItemFormOutlet', ItemFormAdditionalProperties & {
    /** The ID of the outlet that needs to be rendered */
    itemFormOutletId: string;
}, ItemFormAdditionalMethods>;
export declare const renderItemFormOutletBootstrapper: import("../utils").Bootstrapper<"renderItemFormOutlet">;
